#macro Ring(Vector)
sphere_sweep {
linear_spline,
18,
Vector,.03
vaxis_rotate(Vector,y,22.55),.03,
vaxis_rotate(Vector,y,45).03
vaxis_rotate(Vector,y,67.5).03
vaxis_rotate(Vector,y,90).03
vaxis_rotate(Vector,y,112.5).03
vaxis_rotate(Vector,y,135).03
vaxis_rotate(Vector,y,157.5).03
vaxis_rotate(Vector,y,180),.03,
vaxis_rotate(Vector,y,202.5).03
vaxis_rotate(Vector,y,225).03
vaxis_rotate(Vector,y,247.5).03
vaxis_rotate(Vector,y,270).03
vaxis_rotate(Vector,y,292.5).03
vaxis_rotate(Vector,y,315).03
vaxis_rotate(Vector,y,337.5).03
vaxis_rotate(Vector,y,360).03
Vector,.03}
#end

#macro Spokes(Stave)
object {Stave}
object {Stave rotate y*45}
object {Stave rotate y*-45}
object {Stave rotate y*90}
object {Stave rotate y*-90}
object {Stave rotate y*135}
object {Stave rotate y*-135}
object {Stave rotate y*180}
#end

#macro Lathe(Type,Points,
V1,V2,V3,V4,V5,V6,V7,V8,V9,V10,V11,V12,V13,V14,V15,
Color,Texture)  
#switch(Points)
//3 Point Spline
#case(3)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
V1,.03
V2,.03
V3,.03
#if(Type=2)
V3,.03
#end}
union {
object {Spokes}
Ring(V1)
Ring(V2)
Ring(V3)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V1
#end
V1,V2,V3        
#if(Type=2)
V1
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V1
#end
V1,V2,V3        
#if(Type=2)
V1
#end
texture {Texture}}
#end
#break
//4 Point Spline
#case(4)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
#if(Type=2)
V4,.03
#end}
union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V2
#end
V1,V2,V3,V4
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V2
#end
V1,V2,V3,V4
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break
//5 Point Spline
#case(5)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
#if(Type=2)
V5,.03
#end}
union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V3
#end
V1,V2,V3,V4,V5
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V3
#end
V1,V2,V3,V4,V5
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break
//6 Point Spline
#case(6)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
#if(Type=2)
V6,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V4
#end
V1,V2,V3,V4,V5,
V6
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V4
#end
V1,V2,V3,V4,V5,
V6
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break
//7 Point Spline
#case(7)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
#if(Type=2)
V7,.03
#end}
union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V5
#end
V1,V2,V3,V4,V5,
V6,V7
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V5
#end
V1,V2,V3,V4,V5,
V6,V7
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break
//8 Point Spline
#case(8)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
#if(Type=2)
V8,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V6
#end
V1,
V2,
V3,
V4,
V5,
V6,
V7,
V8
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V6
#end
V1,V2,V3,V4,V5,
V6,V7,V8
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break 
//9 Point Spline
#case(9)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
#if(Type=2)
  V9,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V7
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V7
#end
V1,V2,V3,V4,V5,
V6,V7,V8,v9
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break 
//10 Point Spline
#case(10)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
  V10,.03
#if(Type=2)
  V10,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
Ring(V10)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V8
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V8
#end
V1,V2,V3,V4,V5,
V6,V7,V8,v9,V10
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break 
//11 Point Spline
#case(11)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
  V10,.03
  V11,.03
#if(Type=2)
  V11,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
Ring(V10)
Ring(V11)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V9
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V9
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break
//12 Point Spline
#case(12)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
  V10,.03
  V11,.03
  V12,.03
#if(Type=2)
  V12,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
Ring(V10)
Ring(V11)
Ring(V12)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V10
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V10
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break  
//13 Point Spline
#case(13)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
  V10,.03
  V11,.03
  V12,.03
  V13,.03
#if(Type=2)
  V13,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
Ring(V10)
Ring(V11)
Ring(V12)
Ring(V13)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V11
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12,V13
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V11
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12,V13
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break  
//14 Point Spline
#case(14)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
  V10,.03
  V11,.03
  V12,.03
  V13,.03
  V14,.03
#if(Type=2)
  V14,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
Ring(V10)
Ring(V11)
Ring(V12)
Ring(V13)
Ring(V14)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V12
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12,V13,V14
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V12
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12,V13,V14
#if(Type=2)
V3
#end
texture {Texture}}
#end
#break  
//15 Point Spline
#case(15)
#if(View<5)
#declare Profile = sphere_sweep {
#if(Type=1)
linear_spline,
Points,
#else
catmull_rom_spline
Points+2
V1,.03
#end
  V1,.03
  V2,.03
  V3,.03
  V4,.03
  V5,.03
  V6,.03
  V7,.03
  V8,.03
  V9,.03
  V10,.03
  V11,.03
  V12,.03
  V13,.03
  V14,.03
  V15,.03
#if(Type=2)
  V15,.03
#end}
#union {
Spokes(Profile)
Ring(V1)
Ring(V2)
Ring(V3)
Ring(V4)
Ring(V5)
Ring(V6)
Ring(V7)
Ring(V8)
Ring(V9)
Ring(V10)
Ring(V11)
Ring(V12)
Ring(V13)
Ring(V14)
Ring(V15)
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V13
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12,V13,V14,V15
#if(Type=2)
V3
#end
pigment {Clear}finish {ambient 0 diffuse 0}}
pigment {Color}
finish {Luminous}
no_shadow}
#else
lathe {
#if(Type=1)
linear_spline
Points,
#else
cubic_spline
Points+2
V13
#end
V1,V2,V3,V4,V5,
V6,V7,V8,V9,V10,
V11,V12,V13,V14,V15
#if(Type=2)
V3
#end
texture {Texture}}
#end
#end  
#end
